invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Controllers/FilesController.cs
using InventoryManagementBackend.Infrastructure.Database.Abstractions;
using InventoryManagementBackend.Infrastructure.Repositories.Abstractions;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace InventoryManagementBackend.Api.Controllers;

[Authorize(Roles = "Admin")]
public class FilesController : Controller
{
    private readonly IUploadManager _uploadManager;
    private readonly IFilesRepository _filesRepository;

    public FilesController(IUploadManager uploadManager, IFilesRepository filesRepository)
    {
        _uploadManager = uploadManager;
        _filesRepository = filesRepository;
    }
    
    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var response = await _filesRepository.GetAsync();

        return View(response);
    }
    
    [HttpPost]
    public async Task<IActionResult> Upload(IFormFile file)
    {
        if (!ModelState.IsValid) return RedirectToAction("UploadFileModal");

        var response = await _uploadManager.Upload(file);

        if (response.HasErrors()) ModelState.AddModelError("", response.GetErrors());

        return Ok(response.Item);
    }
    
    [HttpGet]
    public async Task<IActionResult> Delete(string id)
    {
        var response = await _filesRepository.GetAsync(p => p.Id == id);

        return View(response);
    }
    
    [HttpPost]
    public async Task<IActionResult> Delete(Guid id)
    {
        await _filesRepository.DeleteAsync(id.ToString());

        return RedirectToAction(nameof(Index));
    }
    
    public async Task<IActionResult> FileSelectModal()
    {
        var files = await _filesRepository.GetAsync();
        return PartialView("_FileSelectModal", files);
    }

    public IActionResult UploadFileModal()
    {
        return PartialView("_UploadFileModal");
    }
}

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Controllers/ItemsController.cs
using InventoryManagementBackend.Core.Entities;
using InventoryManagementBackend.Infrastructure.Database.Abstractions;
using InventoryManagementBackend.Infrastructure.Repositories.Abstractions;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.IdentityModel.Tokens;

namespace InventoryManagementBackend.Api.Controllers;

[Authorize(Roles = "Admin")]
public class ItemsController : Controller
{
    private readonly IItemsRepository _itemsRepository;
    private readonly IUploadManager _uploadManager;
    private readonly ILocationsRepository _locationsRepository;
    private readonly IInventoriesRepository _inventoriesRepository;
    

    public ItemsController(IItemsRepository itemsRepository, IUploadManager uploadManager,
        ILocationsRepository locationsRepository, IInventoriesRepository inventoriesRepository)
    {
        _itemsRepository = itemsRepository;
        _uploadManager = uploadManager;
        _locationsRepository = locationsRepository;
        _inventoriesRepository = inventoriesRepository;
    }
    
    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var inventories = await _itemsRepository.GetAsync();
        return View(inventories);
    }
    
    [HttpGet]
    public async Task<IActionResult> Create()
    {
        var locations = await _locationsRepository.GetAsync();
        var inventories = await _inventoriesRepository.GetAsync();
        ViewBag.Locations = locations;
        ViewBag.Inventories = inventories;
        return View();
    }
    
    [HttpPost]
    public async Task<IActionResult> Create(Item item)
    {
        if (!_validItem(item))
        {
            var locations = await _locationsRepository.GetAsync();
            var inventories = await _inventoriesRepository.GetAsync();
            ViewBag.Locations = locations;
            ViewBag.Inventories = inventories;
            return View();
        }
        
        await _itemsRepository.AddAsync(item);

        return RedirectToAction(nameof(Index));
    }
    
    [HttpGet]
    public async Task<IActionResult> Edit(string id)
    {
        var response = await _itemsRepository.GetAsync(p => p.Id == id);
        
        var locations = await _locationsRepository.GetAsync();
        var inventories = await _inventoriesRepository.GetAsync();
        ViewBag.Locations = locations;
        ViewBag.Inventories = inventories;

        return View(response);
    }
    
    [HttpPost]
    public async Task<IActionResult> Edit(Item item)
    {
        if (!_validItem(item))
        {
            var locations = await _locationsRepository.GetAsync();
            var inventories = await _inventoriesRepository.GetAsync();
            ViewBag.Locations = locations;
            ViewBag.Inventories = inventories;
            return View();
        }

        await _itemsRepository.UpdateAsync(item.Id, item);

        return RedirectToAction(nameof(Index));
    }
    
    [HttpGet]
    public async Task<IActionResult> Delete(string id)
    {
        var response = await _itemsRepository.GetAsync(p => p.Id == id);

        return View(response);
    }
    
    [HttpPost]
    public async Task<IActionResult> Delete(Guid id)
    {
        await _itemsRepository.DeleteAsync(id.ToString());

        return RedirectToAction(nameof(Index));
    }
    
    [HttpGet]
    public async Task<IActionResult> Details(string id)
    {
        var response = await _itemsRepository.GetAsync(p => p.Id == id);

        return View(response);
    }
    
    private bool _validItem(Item item)
    {
        return !item.Name.IsNullOrEmpty() && 
               !item.Description.IsNullOrEmpty() && 
               !item.ImageId.IsNullOrEmpty() &&
               !item.LocationId.IsNullOrEmpty() &&
               !item.InventoryId.IsNullOrEmpty();
    }
}

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Controllers/RequestsController.cs
using InventoryManagementBackend.Infrastructure.Database.Abstractions;
using InventoryManagementBackend.Infrastructure.Services.Abstractions;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace InventoryManagementBackend.Api.Controllers;

[Authorize(Roles = "Admin")]
public class RequestsController : Controller
{
    private readonly IRequestsRepository _requestsRepository;
    private readonly IApproveRequestHelper _approveRequestHelper;

    public RequestsController(IRequestsRepository requestsRepository, IApproveRequestHelper approveRequestHelper)
    {
        _requestsRepository = requestsRepository;
        _approveRequestHelper = approveRequestHelper;
    }
    
    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var requests = await _requestsRepository.GetAsync();
        return View(requests);
    }

    [HttpGet]
    public async Task<IActionResult> Approve(string id)
    {
        var request = await _requestsRepository.GetAsync(id);
        return View(request);
    }

    [HttpPost]
    public async Task<IActionResult> Approve(Guid id)
    {
        var request = await _requestsRepository.GetAsync(id.ToString());
        
        if (request is null) return RedirectToAction(nameof(Index));

        await _approveRequestHelper.ApproveRequestAsync(request);
        
        return RedirectToAction(nameof(Index));
    }
}

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Controllers/UsersController.cs
using InventoryManagementBackend.Core.Entities;
using InventoryManagementBackend.Core.Utils;
using InventoryManagementBackend.Infrastructure.Database.Abstractions;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.IdentityModel.Tokens;
using UserOrganization = InventoryManagementBackend.Core.Entities.UserOrganization;

namespace InventoryManagementBackend.Api.Controllers;

[Authorize(Roles = "Admin")]
public class UsersController : Controller
{
    private readonly UserManager<ApplicationUser> _userManager;
    private readonly IUserOrganizationsRepository _userOrganizationsRepository;
    private readonly IOrganizationsRepository _organizationsRepository;
    private readonly IDepartmentsRepository _departmentsRepository;
    
    public UsersController(UserManager<ApplicationUser> userManager, IUserOrganizationsRepository userOrganizationsRepository,
        IOrganizationsRepository organizationsRepository, IDepartmentsRepository departmentsRepository)
    {
        _userManager = userManager;
        _userOrganizationsRepository = userOrganizationsRepository;
        _organizationsRepository = organizationsRepository;
        _departmentsRepository = departmentsRepository;
    }
    
    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var users = await _userManager.Users.ToListAsync();
        var appUsers = new List<UserInAdmin>();

        foreach (var user in users)
        {
            var userOrganizations = await _userOrganizationsRepository.GetOrganizationsForUserAsync(user.Id);
            var organizations = userOrganizations.Select(o => o.Organization);
            var orgNames = String.Join(" ", organizations.Select(o => o.ShortName));
            var roles = await _userManager.GetRolesAsync(user);
            var roleNames = String.Join(" ", roles);
            appUsers.Add(new UserInAdmin
            {
                Id = user.Id,
                Email = user.Email,
                FirstName = user.FirstName,
                LastName = user.LastName,
                Organizations = orgNames,
                Roles = roleNames
            });
        }

        return View(appUsers);
    }
    
    [HttpGet]
    public async Task<IActionResult> Edit(string id)
    {
        var response = await _userManager.FindByIdAsync(id);

        return View(response);
    }
    
    public async Task<IActionResult> Edit(ApplicationUser user)
    {
        if (!_validUser(user))
            return View();
        
        user.Updated = DateTime.Now;

        await _userManager.UpdateAsync(user);

        return RedirectToAction(nameof(Index));
    }
    
    [HttpGet]
    public async Task<IActionResult> Delete(string id)
    {
        var response = await _userManager.FindByIdAsync(id);

        return View(response);
    }
    
    [HttpPost]
    public async Task<IActionResult> Delete(Guid id)
    {
        var user = await _userManager.FindByIdAsync(id.ToString());
        await _userManager.DeleteAsync(user);

        return RedirectToAction(nameof(Index));
    }

    [HttpGet]
    public async Task<IActionResult> Organizations(string id)
    {
        var organizations = await _organizationsRepository.GetAsync();
        var organizationsForUser = new List<OrganizationForUser>();

        var allUserOrganizations = await _userOrganizationsRepository.GetAsync();
        var userOrganizationsIds = allUserOrganizations
            .Where(uo => uo.UserId == id)
            .Select(uo => new OrganizationDepartmentIds
            {
                DepartmentId = uo.DepartmentId ?? "",
                OrganizationId = uo.OrganizationId
            })
            .ToList();
        
        foreach (var organization in organizations)
        {
            var orgDepartments = await _departmentsRepository.GetForOrgIdAsync(organization.Id);
            
            var depId = "";
            var isAssigned = false;
            if (userOrganizationsIds.Any())
            {
                depId = userOrganizationsIds
                    .FirstOrDefault(uo => uo.OrganizationId == organization.Id)?.DepartmentId ?? "";
                isAssigned = userOrganizationsIds
                    .Select(uo => uo.OrganizationId).Contains(organization.Id);
            }
            
            organizationsForUser.Add(new OrganizationForUser
            {
                OrgId = organization.Id,
                UserId = id,
                ShortName = organization.ShortName,
                IsAssigned = isAssigned,
                SelectedDepartment = orgDepartments.FirstOrDefault(d => d.Id == depId),
                Departments = orgDepartments,
            });
        }

        return View(organizationsForUser);
    }
    
    [HttpPost]
    public async Task<IActionResult> AssignOrganization(string orgId, string departmentId, string userId)
    {
        if (orgId.IsNullOrEmpty() || userId.IsNullOrEmpty() || departmentId.IsNullOrEmpty())
        {
            return RedirectToAction(nameof(Index));
        }
        
        var userOrganization = new UserOrganization
        {
            UserId = userId,
            OrganizationId = orgId,
            DepartmentId = departmentId
        };

        await _userOrganizationsRepository.AddAsync(userOrganization);

        return RedirectToAction(nameof(Index));
    }
    
    [HttpPost]
    public async Task<IActionResult> UnAssignOrganization(string orgId, string userId)
    {
        var userOrganization = await _userOrganizationsRepository
            .GetAsync(uo => uo.UserId == userId && uo.OrganizationId == orgId);
        
        if (userOrganization is null) return RedirectToAction(nameof(Index));
        
        await _userOrganizationsRepository.DeleteAsync(userOrganization);
        return RedirectToAction(nameof(Index));
    }
    
    private bool _validUser(ApplicationUser user)
    {
        return !user.FirstName.IsNullOrEmpty() &&
               !user.LastName.IsNullOrEmpty() &&
               !user.Email.IsNullOrEmpty();
    }
}

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Views/Shared/_FileSelectModal.cshtml
@model IEnumerable<InventoryManagementBackend.Core.Entities.File>
@{
    Layout = null;
}

<style>
    .image-preview-container img {
        max-width: 80px;
        max-height: 50px;
        display: block;
        margin: 0 auto;
    }
</style>

<div id="file-list-modal">
    <div class="modal fade smart-modal" tabindex="-1" role="dialog">
        <div class=" modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Select a file</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="container">
                        <div class="d-flex justify-content-end">
                            <button type="button" class="btn btn-primary mb-2"
                                    data-toggle="ajax-modal"
                                    data-callback="fileListModalScripts.fileAdded"
                                    data-url="@Url.Action("UploadFileModal", "Files")">
                                Upload a file
                            </button>
                        </div>
                        <table class="table">
                            <thead>
                            <tr>
                                <th>
                                    @Html.DisplayNameFor(model => model.OriginalName)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.Name)
                                </th>
                                <th>
                                    Preview
                                </th>
                                <th>
                                    Action
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.OriginalName)
                                    </td>
                                    <td>
                                        <a href="@Html.DisplayFor(modelItem => item.Name)" target="_blank">
                                            @Html.DisplayFor(modelItem => item.Name).@Html.DisplayFor(modelItem => item.Extension)
                                        </a>
                                    </td>
                                    <td>
                                        <button class="btn btn-outline-primary select-file-btn btn-sm" data-id="@item.Id" data-original-name="@item.OriginalName" data-link="@item.OriginalName">Select</button>
                                    </td>
                                </tr>
                            }
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-outline-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
</div>
<script>
    var fileListModalScripts = {
        container: null,
        onLoad: function() {
            this.container = $("#file-list-modal");
            this.container.find(".select-file-btn").click(function(e) {
                fileListModalScripts.fileSelected(e, this);
            });
        },
        fileSelected: function(event, element) {
            element = $(element);
            var fileData = element.data();

            var modal = this.container.find(".modal");
            modal.data("result", fileData);
            modal.modal('hide');
        },
        fileAdded: function(fileData) {
            if (!fileData) {
                return;
            }
            // console.log('fileAdded', fileData);
            var modal = this.container.find(".modal");
            modal.data("result", fileData);
            modal.modal('hide');
        }
    }

    fileListModalScripts.onLoad();
</script>

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - Inventory Management</title>
    <link rel="stylesheet" href="~/admin/lib/bootstrap/dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" href="~/admin/css/site.css"/>
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
        <div class="container">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Inventory Management</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            @if (User.Identity.IsAuthenticated)
            {
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Users" asp-action="Index">Users</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Settings" asp-action="Index">Settings</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Files" asp-action="Index">Files</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle text-dark" href="#" id="objectsDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Content
                            </a>
                            <div class="dropdown-menu" aria-labelledby="objectsDropdown">
                                <a class="dropdown-item" asp-area="" asp-controller="Locations" asp-action="Index">Locations</a>
                                <a class="dropdown-item" asp-area="" asp-controller="Organizations" asp-action="Index">Organizations</a>
                                <a class="dropdown-item" asp-area="" asp-controller="Departments" asp-action="Index">Departments</a>
                                <a class="dropdown-item" asp-area="" asp-controller="Inventories" asp-action="Index">Inventories</a>
                                <a class="dropdown-item" asp-area="" asp-controller="Items" asp-action="Index">Items</a>
                            </div>
                        </li> 
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Requests" asp-action="Index">Approve requests</a>
                        </li>
                    </ul>
                    <partial name="_LoginPartial"/>
                </div>
            }
            </div>
    </nav>
</header>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted">
    <div class="container">
        &copy; 2024 - InventoryManagement
    </div>
</footer>
<script src="~/admin/lib/jquery/dist/jquery.min.js"></script>
<script src="~/admin/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<script src="~/admin/js/site.js" asp-append-version="true"></script>
@await RenderSectionAsync("Scripts", false)
</body>
</html>

invetory-management-backend/InventoryManagementBackend/InventoryManagementBackend.Api/Views/Shared/_UploadFileModal.cshtml
<div class="modal fade smart-modal no-scroll" tabindex="1" role="dialog" id="file-upload-container">
    <div class=" modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Upload a file</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form>
                    <div class="form-group">
                        <label ></label>
                        <input class="form-control" type="file" placeholder="Select a file"/>
                        <span class="text-danger"></span>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-outline-secondary" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary upload-button">Upload</button>
            </div>
        </div>
    </div>
</div>

<script>
    var fileUploadModalScripts = {
        container: null,
        fileName: null,
        uploadButtonClick: function(e) {
                    var fileInput = this.container.find("input[type=file]")[0];
                    var formData = new FormData();
        
                    var file = fileInput.files[0];
                    this.fileName = file.name;
                    formData.append("file", file);
        
                    var request = new XMLHttpRequest();
                    request.onload =
                        function(e) {
                            fileUploadModalScripts.uploaded(JSON.parse(this.responseText));
                        };
                    request.open("POST", '@Url.Action("Upload", "Files")');
                    request.send(formData);
                },
                uploaded: function(e) {
                    if (!e) {
                        alert("Something went wrong with the upload!");
                        return;
                    }
                    var file = e;
                    file.originalName = this.fileName;
                    this.container.data("result", file);
                    this.container.modal("hide");
                },
                onLoad: function() {
                    this.container = $("#file-upload-container");
                    this.container.find(".upload-button").click(function(e) {
                        fileUploadModalScripts.uploadButtonClick(e);
                    });

        }
    }

    fileUploadModalScripts.onLoad();
</script>